//NAMED WEAPONS STATS
::mods_hookBaseClass("items/weapons/named/named_weapon", function (o) {
	while(!("randomizeValues" in o)) o = o[o.SuperName]; //find where the function is first called
	o.randomizeValues = function()
	{
		if (this.m.ConditionMax > 1)
		{
            this.m.Condition = this.Math.round(this.m.Condition * this.Math.rand(100, 150) * 0.01) * 1.0;
		    this.m.ConditionMax = this.m.Condition;
		}
		else //throwing weapons
		{
            this.m.AmmoMax = this.m.AmmoMax + this.Math.rand(2, 4);
            this.m.Ammo = this.m.AmmoMax;
		}

		local possibleBuffs = [];
		possibleBuffs.push(function ( _i )
		{
			local f = this.Math.rand(115, 133) * 0.01;
			_i.m.RegularDamage = this.Math.round(_i.m.RegularDamage * f);
			_i.m.RegularDamageMax = this.Math.round(_i.m.RegularDamageMax * f);
		});
		possibleBuffs.push(function ( _i )
		{
			_i.m.ArmorDamageMult = _i.m.ArmorDamageMult + this.Math.rand(15, 30) * 0.01;
		});

		if (this.m.ChanceToHitHead > 0)
		{
			possibleBuffs.push(function ( _i )
			{
				_i.m.ChanceToHitHead = _i.m.ChanceToHitHead + this.Math.rand(10, 20);
			});
		}

		possibleBuffs.push(function ( _i )
		{
			_i.m.DirectDamageAdd = _i.m.DirectDamageAdd + this.Math.rand(10, 18) * 0.01;
		});

		if (this.m.StaminaModifier <= -10)
		{
			possibleBuffs.push(function ( _i )
			{
				_i.m.StaminaModifier = this.Math.round(_i.m.StaminaModifier * this.Math.rand(50, 75) * 0.01);
			});
		}

		if (this.m.ShieldDamage >= 16)
		{
			possibleBuffs.push(function ( _i )
			{
				_i.m.ShieldDamage = this.Math.round(_i.m.ShieldDamage * this.Math.rand(133, 180) * 0.01);
			});
		}

		if (this.m.AdditionalAccuracy != 0 || this.isItemType(this.Const.Items.ItemType.RangedWeapon))
		{
			possibleBuffs.push(function ( _i )
			{
				_i.m.AdditionalAccuracy = _i.m.AdditionalAccuracy + this.Math.rand(10, 15);
			});
		}

		possibleBuffs.push(function ( _i )
		{
			_i.m.FatigueOnSkillUse = _i.m.FatigueOnSkillUse - this.Math.rand(2, 3);
		});

		for( local n = 3; n != 0 && possibleBuffs.len() != 0; n-- )
		{
			local r = this.Math.rand(0, possibleBuffs.len() - 1);
			possibleBuffs[r](this);
			possibleBuffs.remove(r);
		}
	}
});